<template>
  <div v-if="isLoaded" class="flex flex-col content-center justify-center mt-5">
    <div class="card text-center">
      <div class="rounded w-max mx-auto bg-green-500 border-green p-5">
        The application is currently running on
        <span class="rounded bg-green-200 p-1"> {{ url }}</span>
      </div>
    </div>
    <div v-if="selectedUser" class="card text-center">
      <h3 class="text-xl mt-5">QR code example</h3>
      <div class="mx-auto rounded w-max border-2 border-black px-6 py-4 mt-5">
        <p class="font-bold">User data</p>
        <p>Name: {{ selectedUser.name }}</p>
        <p>Surname: {{ selectedUser.surname }}</p>
      </div>
      <img class="mx-auto" height="50" :src="qrcode" alt="" />
    </div>
    <div v-else class="card text-center mt-5">
      <div class="rounded w-max mx-auto bg-red-500 border-green p-5">
        If you see this, you need to open the application from i3hub
        <a class="bg-red-200 p-1 rounded" href="https://hub.i3lab.group"
          >https://hub.i3lab.group</a
        >
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios'
import QRCode from 'qrcode'
import i3hubMixin from '~/mixins/i3hub.mixin'
export default {
  mixins: [i3hubMixin],
  name: 'IndexPage',
  data() {
    return {
      isLoaded: false,
      qrcode: '',
      selectedUser: null,
      sessionId: '',
      url: '',
    }
  },
  async mounted() {
    this.url = window.location.href
    try {
      this.parsePayload()
      this.selectedUser = this.currentSubjects[0]
      this.sessionId = (await axios.post('/api/session')).data
      console.log(this.selectedUser)
      const qrPayload = {
        sessionId: this.sessionId,
        user: {
          name: this.selectedUser.name,
          surname: this.selectedUser.surname,
        },
      }
      this.qrcode = await QRCode.toDataURL(JSON.stringify(qrPayload))
    } catch (e) {
      console.log(e)
    } finally {
      this.isLoaded = true
    }
  },
}
</script>
